REBOL []

do %send-keys.r

;print "Testing..."

; Here's a handy hint: If you send keystrokes to a window that may cause a
; dialog, or other window, to be displayed, do NOT use /to-window. /to-window
; causes the engine to try to activate the specified window for each keystroke
; and if a modal dialog is up in front of it, things may hang.      Gregg

win-shell/win-exec 0 "open" "notepad.exe" "" "" 1
wait 1
win-shell/activate "Untitled - Notepad"

win-send-keys compose [
    "Gregg" return tab F5
    alt #"f" #"o" wait 0:0:0.1 alt "n" wait .5 escape
    {^/This is some more text (with a "quote")...
    no less. }
    divide return
    shift ["i" shift-up "rwin"] return
    shift "i" "rwin" return
    "Irwin" return
    shift "irwin" " irwin" return
    shift ["ir" "win"] return
    shift ["ir" tab "win"] return
    "0" 10 return
    (s: copy "" repeat i 10 [append s form i]) return
    (do func [/local s] [s: copy "" repeat i 10 [append s to char! add i 64] s]) return
    ctrl "s" wait .5 escape return
]

win-send-keys/to-window/delay [
    {Win API docs on extended keys:
    The extended-key flag indicates whether the keystroke message originated from
    one of the additional keys on the enhanced keyboard. The extended keys consist
    of the alt and ctrl keys on the right-hand side of the keyboard; the ins, del,
    home, end, page up, page down and arrow keys in the clusters to the left of the
    numeric keypad; the num lock key; the break (ctrl+pause) key; the print scrn
    key; and the divide (/) and enter keys in the numeric keypad. The extended-key
    flag is set if the key is an extended key.} return
] "Untitled - Notepad" 0

win-send-keys [return return "Done!"]

